// Copyright (C) 2013-2020 Altera Corporation, San Jose, California, USA. All rights reserved.
// Permission is hereby granted, free of charge, to any person obtaining a copy of this
// software and associated documentation files (the "Software"), to deal in the Software
// without restriction, including without limitation the rights to use, copy, modify, merge,
// publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to
// whom the Software is furnished to do so, subject to the following conditions:
// The above copyright notice and this permission notice shall be included in all copies or
// substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//
// This agreement shall be governed in all respects by the laws of the State of California and
// by the laws of the United States of America.

/**
 * @details
 *      1D complex floating-point feed-forward radix-4 FFT / iFFT
 *      Processes 4 points in parallel.
 *      See bigger comments in fft_8.cl for more information.
 *      the input is ordered, the output is bit reversed
 *      Twid_4.h generated by genscript/generate_twid_mod_4p.m
 *      Twid_4.h can be recreated by changing LOGN, i.e. FFT size
 */


#include "Twid_4.h"

float_vector butterfly(float_vector data) {
   float_vector res;
   res.i0 = data.i0 + data.i1;
   res.i1 = data.i0 - data.i1;
   res.i2 = data.i2 + data.i3;
   res.i3 = data.i2 - data.i3;
   return res;
}

float_vector swap_complex(float_vector data) {
   float_vector res;
   res.i0.x = data.i0.y;
   res.i0.y = data.i0.x;
   res.i1.x = data.i1.y;
   res.i1.y = data.i1.x;
   res.i2.x = data.i2.y;
   res.i2.y = data.i2.x;
   res.i3.x = data.i3.y;
   res.i3.y = data.i3.x;
   return res;
}

float_vector trivial_rotate(float_vector data) {
   TYPE tmp = data.i3;
   data.i3.x = tmp.y;
   data.i3.y = -tmp.x;
   return data;
}

float_vector swap(float_vector data) {
   TYPE tmp = data.i1;
   data.i1 = data.i2;
   data.i2 = tmp;
   return data;
}

float2x2 delay_data(float2x2 data, const uint depth, const uint depth_mod_mask,
                local float2x2 *shift_reg, uint inv_count) {
   uint read_addr  = (0 + inv_count)     & depth_mod_mask;
   uint write_addr = (depth + inv_count) & depth_mod_mask;
   shift_reg[write_addr] = data;
   return shift_reg[read_addr];
}

float_vector reorder_data(float_vector data, const uint depth, const uint depth_mod_mask,
      local TYPE *delay1,
      local TYPE *delay2,
      uint inv_count, const uint stage, bool toggle) {
   // Use disconnected segments of length 'depth + 1' elements starting at
   // 'shift_reg' to implement the delay elements. At the end of each FFT step,
   // the contents of the entire buffer is shifted by 1 element
   float2x2 t;
   t.i0 = data.i1;
   t.i1 = data.i3;
   t = delay_data(t, depth, depth_mod_mask, (local float2x2*)delay1, inv_count);
   data.i1 = t.i0;
   data.i3 = t.i1;

   if (toggle) {
      TYPE tmp = data.i0;
      data.i0 = data.i1;
      data.i1 = tmp;
      tmp = data.i2;
      data.i2 = data.i3;
      data.i3 = tmp;
   }

   t.i0 = data.i0;
   t.i1 = data.i2;
   t = delay_data(t, depth, depth_mod_mask, (local float2x2*)delay2, inv_count);
   data.i0 = t.i0;
   data.i2 = t.i1;

   return data;
}

TYPE twiddle(uint index, uint stage, uint log_size, uint stream) {
   TYPE twid;

   constant float * twiddles_cos[TWID_STAGES][3] = {{tc00, tc01, tc02},
                                                    {tc10, tc11, tc12},
                                                    {tc20, tc21, tc22},
                                                    {tc30, tc31, tc32},
                                                    {tc40, tc41, tc42},
                                                    {tc50, tc51, tc52},
                                                    {tc60, tc61, tc62}
   };
   constant float * twiddles_sin[TWID_STAGES][3] = {{ts00, ts01, ts02},
                                                    {ts10, ts11, ts12},
                                                    {ts20, ts21, ts22},
                                                    {ts30, ts31, ts32},
                                                    {ts40, ts41, ts42},
                                                    {ts50, ts51, ts52},
                                                    {ts60, ts61, ts62}
   };

   // use the hardcoded twiddle fators, if available - otherwise, compute them
   uint twid_stage = stage >> 1;
   if (log_size <= (TWID_STAGES * 2 + 2)) {
      uint index_mult = 1 << (TWID_STAGES * 2 + 2 - log_size);
      twid.x = twiddles_cos[twid_stage][stream][index * index_mult];
      twid.y = twiddles_sin[twid_stage][stream][index * index_mult];

   }
   else{
      twid.x=0;
      twid.y=0;
   }
   return twid;
}

float2x3 get_twid(uint index, uint stage, uint log_size) {
  float2x3 result;
  result.i0 = twiddle(index, stage, log_size, 0);
  result.i1 = twiddle(index, stage, log_size, 1);
  result.i2 = twiddle(index, stage, log_size, 2);
  return result;
}

float_vector complex_rotate_given_twid(float_vector data, float2x3 twid) {
   data.i1 = comp_mult(data.i1, twid.i0);
   data.i2 = comp_mult(data.i2, twid.i1);
   data.i3 = comp_mult(data.i3, twid.i2);
   return data;
}

// FFT complex rotation building block
float_vector complex_rotate(float_vector data, uint index, uint stage, uint log_size, bool bypass) {
  float2x3 twid = get_twid(index, stage, log_size);
  if (bypass) {
    twid.i0.x = 1.0f; twid.i0.y = 0.0f;
    twid.i1.x = 1.0f; twid.i1.y = 0.0f;
    twid.i2.x = 1.0f; twid.i2.y = 0.0f;
  }
  return complex_rotate_given_twid(data, twid);
}

typedef struct {
  float_vector data;
  uint size;
  uint logM;
  uint step;
  uint inv_count;
  uint two_to_logM_m_stage;
  uint delay;
  uint delay_mod_mask;
} interstage_data;

interstage_data do_single_stage (const uint stage, interstage_data d,
                                 local TYPE *delay1,
                                 local TYPE *delay2)
{
  bool complex_stage = stage & 1;
  bool process_stage = (stage < (d.logM - 1));

  uint data_index = d.step;

  if (process_stage) d.data = butterfly(d.data);

  if (complex_stage) {
    d.data = complex_rotate(d.data, data_index, stage, d.logM, !process_stage);
  }

  if (process_stage) d.data = swap(d.data);

  // Reordering multiplexers must toggle every 'delay' steps
  bool toggle = data_index & d.delay;


  // Assign unique sections of the buffer for the set of delay elements at
  // each stage
  uint delay_arg = process_stage ? d.delay : 0;
  uint toggle_arg = process_stage ? toggle : 0;

  d.data = reorder_data(d.data, delay_arg, d.delay_mod_mask, delay1, delay2, d.inv_count, stage, toggle_arg);

  if (!complex_stage && process_stage) {
    d.data = trivial_rotate(d.data);
  }

  // update for next call
  d.two_to_logM_m_stage >>= 1;
  d.delay >>= 1;
  d.delay_mod_mask >>= 1;

  return d;
}


// process 4 input points towards and a FFT/iFFT of size N, N >= 4
float_vector fft_step(float_vector data, uint inv_count, uint step,
                  local TYPE *delay1, local TYPE *delay11,
                  local TYPE *delay2, local TYPE *delay21,
                  local TYPE *delay3, local TYPE *delay31,
                  local TYPE *delay4, local TYPE *delay41,
                  local TYPE *delay5, local TYPE *delay51,
                  local TYPE *delay6, local TYPE *delay61,
                  local TYPE *delay7, local TYPE *delay71,
                  local TYPE *delay8, local TYPE *delay81,
                  local TYPE *delay9, local TYPE *delay91,
                  local TYPE *delayA, local TYPE *delayA1,
                  local TYPE *delayB, local TYPE *delayB1,
                  local TYPE *delayC, local TYPE *delayC1,
                  local TYPE *delayD, local TYPE *delayD1,
                  bool inverse, const uint logN, const uint logM, const uint size) {

    // Swap real and imaginary components if doing an inverse transform
    if (inverse) {
       data = swap_complex(data);
    }

    // Stage 0 of feed-forward FFT
    data = butterfly(data);
    data = trivial_rotate(data);
    data = swap(data);


    // next logN - 1 stages alternate two computation patterns
    interstage_data d;
    d.data = data;
    d.size = size;
    d.logM = logM;
    d.step = step;
    d.inv_count = inv_count;
    d.two_to_logM_m_stage = size >> 3;
    d.delay = size >> 3;
    d.delay_mod_mask = 2 * d.delay - 1;

    d = do_single_stage (1, d, delay1, delay11);

#if LOGN>3
    d = do_single_stage (2, d, delay2, delay21);
#endif
#if LOGN>4
    d = do_single_stage (3, d, delay3, delay31);
#endif
#if LOGN>5
    d = do_single_stage (4, d, delay4, delay41);
#endif
#if LOGN>6
    d = do_single_stage (5, d, delay5, delay51);
#endif
#if LOGN>7
    d = do_single_stage (6, d, delay6, delay61);
#endif
#if LOGN>8
    d = do_single_stage (7, d, delay7, delay71);
#endif
#if LOGN>9
    d = do_single_stage (8, d, delay8, delay81);
#endif
#if LOGN>10
    d = do_single_stage (9, d, delay9, delay91);
#endif
#if LOGN>11
    d = do_single_stage (10, d, delayA, delayA1);
#endif
#if LOGN>12
    d = do_single_stage (11, d, delayB, delayB1);
#endif
#if LOGN>13
    d = do_single_stage (12, d, delayC, delayC1);
#endif
#if LOGN>14
    d = do_single_stage (13, d, delayD, delayD1);
#endif
#if LOGN>15
  #error "LOGN is too big.\nYou need to regenerate constant twiddle factors to support larger sizes."
#endif

    data = d.data;

    // stage logN - 1
    data = butterfly(data);

    if (inverse) {
       data = swap_complex(data);
    }

    return data;
}
